## hydrasdr-host 1.1.0

=== CMakeLists.txt ===
# top dir cmake project for libhydrasdr + hydrasdr-tools

cmake_minimum_required(VERSION 3.10)

########################################################################
# Dependency Versions (used by FetchContent for MSVC builds)
########################################################################
set(LIBUSB_VERSION "1.0.29")
set(PTHREADS4W_VERSION "3.0.0")

# MSVC builds require CMake 3.18+ for:
# - FetchContent support
# - Native 7z archive extraction via file(ARCHIVE_EXTRACT)
if(MSVC)
  if(CMAKE_VERSION VERSION_LESS "3.18")
    message(FATAL_ERROR "MSVC builds require CMake 3.18+ for FetchContent and native 7z extraction. "
                        "Current version: ${CMAKE_VERSION}")
  endif()
endif()

# Disable vcpkg integration if accidentally inherited from environment
# This project manages its own dependencies and doesn't need vcpkg
set(VCPKG_MANIFEST_MODE OFF)
set(VCPKG_APPLOCAL_DEPS OFF)
if(DEFINED ENV{VCPKG_ROOT})
  message(STATUS "Note: VCPKG_ROOT is set but this project doesn't use vcpkg")
endif()

project(hydrasdr-host LANGUAGES C HOMEPAGE_URL https://hydrasdr.com)
set(CMAKE_VERBOSE_MAKEFILE ON)
set(CMAKE_EXPORT_COMPILE_COMMANDS ON)

########################################################################
# Set consistent install prefix for Windows (both MSVC and MinGW)
########################################################################
if(WIN32 AND CMAKE_INSTALL_PREFIX_INITIALIZED_TO_DEFAULT)
  set(CMAKE_INSTALL_PREFIX "C:/Program Files/${PROJECT_NAME}" CACHE PATH
    "Install path prefix" FORCE)
  message(STATUS "Install prefix set to: ${CMAKE_INSTALL_PREFIX}")
endif()

if(NOT CMAKE_BUILD_TYPE)
  message(STATUS "Build type not specified: defaulting to Release.")
  set(CMAKE_BUILD_TYPE Release)
endif()

#provide missing strtoull() for VC11
if(MSVC11)
  message("provide missing strtoull() for VC11")
  add_definitions(-Dstrtoull=_strtoui64)
endif(MSVC11)

if(MSVC)
  message("define _TIMESPEC_DEFINED and _CRT_SECURE_NO_WARNINGS() for MSVC")
  add_compile_definitions(_TIMESPEC_DEFINED _CRT_SECURE_NO_WARNINGS)
endif(MSVC)

########################################################################
# FetchContent Dependencies for MSVC builds
########################################################################
if(MSVC)
  include(FetchContent)

  # ====================================================================
  # libusb - Use pre-provided paths or download pre-built Windows binaries
  # ====================================================================
  # If LIBUSB_INCLUDE_DIR and LIBUSB_LIBRARIES are already provided (e.g., from CI),
  # use those instead of downloading via FetchContent.
  if(LIBUSB_INCLUDE_DIR AND LIBUSB_LIBRARIES AND EXISTS "${LIBUSB_LIBRARIES}")
    message(STATUS "Using pre-provided libusb:")
    message(STATUS "  Include: ${LIBUSB_INCLUDE_DIR}")
    message(STATUS "  Library: ${LIBUSB_LIBRARIES}")

    set(LIBUSB_LIBRARY "${LIBUSB_LIBRARIES}" CACHE FILEPATH "libusb import library" FORCE)
    if(NOT LIBUSB_DLL)
      get_filename_component(_libusb_lib_dir "${LIBUSB_LIBRARIES}" DIRECTORY)
      # Check same directory as .lib first, then sibling bin/ directory
      if(EXISTS "${_libusb_lib_dir}/libusb-1.0.dll")
        set(LIBUSB_DLL "${_libusb_lib_dir}/libusb-1.0.dll" CACHE FILEPATH "libusb DLL" FORCE)
      else()
        get_filename_component(_libusb_parent_dir "${_libusb_lib_dir}" DIRECTORY)
        set(LIBUSB_DLL "${_libusb_parent_dir}/bin/libusb-1.0.dll" CACHE FILEPATH "libusb DLL" FORCE)
      endif()
    endif()

    add_library(LIBUSB::LIBUSB SHARED IMPORTED GLOBAL)
    set_target_properties(LIBUSB::LIBUSB PROPERTIES
      IMPORTED_LOCATION "${LIBUSB_DLL}"
      IMPORTED_IMPLIB "${LIBUSB_LIBRARY}"
      INTERFACE_INCLUDE_DIRECTORIES "${LIBUSB_INCLUDE_DIR}"
    )
    set(LIBUSB_FOUND TRUE CACHE BOOL "libusb found" FORCE)
    set(LIBUSB_USE_DLL TRUE CACHE BOOL "Using libusb DLL" FORCE)
  else()
    # Download libusb pre-built binaries
    set(LIBUSB_ARCHIVE_URL "https://github.com/libusb/libusb/releases/download/v${LIBUSB_VERSION}/libusb-${LIBUSB_VERSION}.7z")
    set(LIBUSB_DOWNLOAD_DIR "${CMAKE_BINARY_DIR}/_deps/libusb-${LIBUSB_VERSION}")
    set(LIBUSB_ARCHIVE_FILE "${LIBUSB_DOWNLOAD_DIR}/libusb-${LIBUSB_VERSION}.7z")

    if(NOT EXISTS "${LIBUSB_DOWNLOAD_DIR}/include/libusb-1.0/libusb.h")
      message(STATUS "Downloading libusb ${LIBUSB_VERSION} pre-built binaries...")
      file(MAKE_DIRECTORY "${LIBUSB_DOWNLOAD_DIR}")

      if(NOT EXISTS "${LIBUSB_ARCHIVE_FILE}")
        file(DOWNLOAD
          "${LIBUSB_ARCHIVE_URL}"
          "${LIBUSB_ARCHIVE_FILE}"
          SHOW_PROGRESS
          STATUS DOWNLOAD_STATUS
        )
        list(GET DOWNLOAD_STATUS 0 STATUS_CODE)
        if(NOT STATUS_CODE EQUAL 0)
          message(FATAL_ERROR "Failed to download libusb: ${DOWNLOAD_STATUS}")
        endif()
      endif()

      message(STATUS "Extracting libusb ${LIBUSB_VERSION}...")
      file(ARCHIVE_EXTRACT
        INPUT "${LIBUSB_ARCHIVE_FILE}"
        DESTINATION "${LIBUSB_DOWNLOAD_DIR}"
      )
    endif()

    if(MSVC_VERSION GREATER_EQUAL 1930)
      set(LIBUSB_VS_DIR "VS2022")
    elseif(MSVC_VERSION GREATER_EQUAL 1920)
      set(LIBUSB_VS_DIR "VS2019")
    else()
      set(LIBUSB_VS_DIR "VS2015")
    endif()

    set(LIBUSB_INCLUDE_DIR "${LIBUSB_DOWNLOAD_DIR}/include" CACHE PATH "libusb include directory" FORCE)
    set(LIBUSB_LIBRARY "${LIBUSB_DOWNLOAD_DIR}/${LIBUSB_VS_DIR}/MS64/dll/libusb-1.0.lib" CACHE FILEPATH "libusb import library" FORCE)
    set(LIBUSB_DLL "${LIBUSB_DOWNLOAD_DIR}/${LIBUSB_VS_DIR}/MS64/dll/libusb-1.0.dll" CACHE FILEPATH "libusb DLL" FORCE)

    if(NOT EXISTS "${LIBUSB_INCLUDE_DIR}/libusb.h")
      message(FATAL_ERROR "libusb header not found at ${LIBUSB_INCLUDE_DIR}/libusb.h")
    endif()
    if(NOT EXISTS "${LIBUSB_LIBRARY}")
      message(FATAL_ERROR "libusb import library not found at ${LIBUSB_LIBRARY}")
    endif()
    if(NOT EXISTS "${LIBUSB_DLL}")
      message(FATAL_ERROR "libusb DLL not found at ${LIBUSB_DLL}")
    endif()

    add_library(LIBUSB::LIBUSB SHARED IMPORTED GLOBAL)
    set_target_properties(LIBUSB::LIBUSB PROPERTIES
      IMPORTED_LOCATION "${LIBUSB_DLL}"
      IMPORTED_IMPLIB "${LIBUSB_LIBRARY}"
      INTERFACE_INCLUDE_DIRECTORIES "${LIBUSB_INCLUDE_DIR}"
    )

    set(LIBUSB_FOUND TRUE CACHE BOOL "libusb found" FORCE)
    set(LIBUSB_USE_DLL TRUE CACHE BOOL "Using libusb DLL" FORCE)

    message(STATUS "libusb ${LIBUSB_VERSION} (${LIBUSB_VS_DIR}):")
    message(STATUS "  Include: ${LIBUSB_INCLUDE_DIR}")
    message(STATUS "  Library: ${LIBUSB_LIBRARY}")
    message(STATUS "  DLL:     ${LIBUSB_DLL}")
  endif()

  # ====================================================================
  # pthreads4w - Build from source for static linking
  # ====================================================================
  # pthreads4w is the official continuation of pthreads-win32
  # Building from source ensures proper static library support

  FetchContent_Declare(
    pthreads4w
    GIT_REPOSITORY "https://github.com/jwinarske/pthreads4w.git"
    GIT_TAG "Version-3-0-0-release"
    GIT_SHALLOW TRUE
  )

  message(STATUS "Downloading pthreads4w ${PTHREADS4W_VERSION}...")
  FetchContent_MakeAvailable(pthreads4w)

  # pthreads4w has its own CMakeLists.txt that creates pthreadVC3 and pthreadVC3-static targets
  # We'll use the static target
  if(TARGET pthreadVC3-static)
    # Configure the static target for our needs
    target_compile_definitions(pthreadVC3-static PUBLIC PTW32_STATIC_LIB)

    # Create an alias for easier reference
    add_library(pthreads4w_static ALIAS pthreadVC3-static)

    # Set paths for downstream use
    set(THREADS_PTHREADS_INCLUDE_DIR "${pthreads4w_SOURCE_DIR}" CACHE PATH "pthreads include directory" FORCE)
    set(THREADS_PTHREADS_WIN32_LIBRARY pthreadVC3-static CACHE STRING "pthreads library target" FORCE)

    message(STATUS "pthreads4w source: ${pthreads4w_SOURCE_DIR}")
    message(STATUS "pthreads4w using pthreadVC3-static target")
  elseif(EXISTS "${pthreads4w_SOURCE_DIR}/pthread.c")
    # Fallback: Build manually if CMake targets not available
    add_library(pthreads4w_static STATIC
      "${pthreads4w_SOURCE_DIR}/pthread.c"
    )
    target_include_directories(pthreads4w_static PUBLIC "${pthreads4w_SOURCE_DIR}")
    target_compile_definitions(pthreads4w_static PUBLIC
      PTW32_STATIC_LIB
      HAVE_CONFIG_H
    )
    target_compile_definitions(pthreads4w_static PRIVATE
      PTW32_BUILD
      _TIMESPEC_DEFINED
    )
    # Use static runtime
    target_compile_options(pthreads4w_static PRIVATE
      $<$<CONFIG:Debug>:/MTd>
      $<$<CONFIG:Release>:/MT>
    )

    set(THREADS_PTHREADS_INCLUDE_DIR "${pthreads4w_SOURCE_DIR}" CACHE PATH "pthreads include directory" FORCE)
    set(THREADS_PTHREADS_WIN32_LIBRARY pthreads4w_static CACHE STRING "pthreads library target" FORCE)

    message(STATUS "pthreads4w built manually from source")
  else()
    message(FATAL_ERROR "pthreads4w: No suitable build method found")
  endif()

endif() # MSVC

########################################################################
# Code Coverage Support (GCC/Clang only)
########################################################################
option(ENABLE_COVERAGE "Enable code coverage with gcov" OFF)

if(ENABLE_COVERAGE AND NOT MSVC)
  message(STATUS "Code coverage enabled - adding coverage flags to all targets")
  set(COVERAGE_COMPILE_FLAGS "-fprofile-arcs -ftest-coverage")
  set(COVERAGE_LINK_FLAGS "-lgcov --coverage")
  set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} ${COVERAGE_COMPILE_FLAGS}")
  set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} ${COVERAGE_LINK_FLAGS}")
  set(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} ${COVERAGE_LINK_FLAGS}")
endif()

add_subdirectory(libhydrasdr)
add_subdirectory(hydrasdr-tools)

########################################################################
# CTest Integration (for running tests)
########################################################################
# Enable CTest at top level so 'ctest' command works from build directory
include(CTest)
enable_testing()

########################################################################
# Create uninstall target
########################################################################

configure_file(
  ${PROJECT_SOURCE_DIR}/cmake/cmake_uninstall.cmake.in
  ${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake
@ONLY)

add_custom_target(uninstall
  COMMENT "Provide uninstall target"
  COMMAND ${CMAKE_COMMAND} -P ${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake
)

########################################################################
# Copy Files for Windows builds
########################################################################

if(WIN32 AND MINGW)
  message("copy libusb-1.0.dll for MinGW")

  # Find the directory where the compiler is (e.g. .../mingw64/bin)
  get_filename_component(_MINGW_BIN ${CMAKE_C_COMPILER} DIRECTORY)

  # Find the DLL in that directory
  find_file(LIBUSB_1_0_DLL libusb-1.0.dll
    HINTS ${_MINGW_BIN}
    NO_DEFAULT_PATH
  )

  if(LIBUSB_1_0_DLL)
    message(STATUS "Found libusb-1.0.dll at ${LIBUSB_1_0_DLL}")
    configure_file(
      ${LIBUSB_1_0_DLL}
      ${CMAKE_CURRENT_BINARY_DIR}/hydrasdr-tools/src/libusb-1.0.dll
      COPYONLY)
  else()
    message(WARNING "libusb-1.0.dll not found in ${_MINGW_BIN}, skipping copy.")
  endif()
endif()

# For MSVC builds: libusb DLL copy is handled by POST_BUILD commands in hydrasdr-tools/src/CMakeLists.txt
# This ensures DLLs are copied at BUILD time (not just configure time) and works reliably on first build
if(MSVC AND LIBUSB_USE_DLL)
  message(STATUS "libusb DLL will be copied at build time via POST_BUILD commands")
  # Also install libusb DLL and import library for 'cmake --install' target
  if(LIBUSB_DLL AND EXISTS "${LIBUSB_DLL}")
    install(FILES "${LIBUSB_DLL}" DESTINATION ${CMAKE_INSTALL_BINDIR} COMPONENT runtime)
  endif()
  if(LIBUSB_LIBRARY AND EXISTS "${LIBUSB_LIBRARY}")

=== hydrasdr-tools/CMakeLists.txt ===
# Copyright 2012 Jared Boone
# Copyright 2013-2026 Benjamin Vernoux
#
# This file is part of HydraSDR (based on HackRF project).
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2, or (at your option)
# any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; see the file COPYING.  If not, write to
# the Free Software Foundation, Inc., 51 Franklin Street,
# Boston, MA 02110-1301, USA.

cmake_minimum_required(VERSION 3.10)
project(hydrasdr-tools LANGUAGES C VERSION 1.0)
include(GNUInstallDirs)
set(MAJOR_VERSION 1)
set(MINOR_VERSION 0)
set(PACKAGE hydrasdr-tools)
set(VERSION_STRING ${MAJOR_VERSION}.${MINOR_VERSION})
set(VERSION ${VERSION_STRING})
set(CMAKE_MODULE_PATH ${PROJECT_SOURCE_DIR}/../cmake/modules)
add_definitions(-D_FILE_OFFSET_BITS=64)

if(MSVC)
  include_directories(getopt)
  add_definitions(/D _CRT_SECURE_NO_WARNINGS)
  # Enable static runtime for both debug and release
  foreach(flag_var
      CMAKE_C_FLAGS CMAKE_C_FLAGS_DEBUG CMAKE_C_FLAGS_RELEASE
      CMAKE_C_FLAGS_MINSIZEREL CMAKE_C_FLAGS_RELWITHDEBINFO)
    if(${flag_var} MATCHES "/MD")
      string(REGEX REPLACE "/MD" "/MT" ${flag_var} "${${flag_var}}")
    endif()
  endforeach()
else()
  add_definitions(-Wall)
endif()

if(libhydrasdr_SOURCE_DIR)
  if(TARGET hydrasdr)
    add_library(HydraSDR::hydrasdr ALIAS hydrasdr)
  else()
    add_library(HydraSDR::hydrasdr ALIAS hydrasdr_static)
  endif()
elseif(LIBHYDRASDR_INCLUDE_DIR AND LIBHYDRASDR_LIBRARIES
    AND NOT TARGET HydraSDR::hydrasdr)
  add_library(HydraSDR::hydrasdr INTERFACE IMPORTED)
  set_target_properties(
    HydraSDR::hydrasdr
    PROPERTIES INTERFACE_INCLUDE_DIRECTORIES "${LIBHYDRASDR_INCLUDE_DIR}"
    INTERFACE_LINK_LIBRARIES "${LIBHYDRASDR_LIBRARIES}")
else()
  message(STATUS "finding library for hydrasdr-tools")
  find_package(HydraSDR REQUIRED)
endif()

add_subdirectory(src)

# Build tests if BUILD_TESTS option is enabled (default: ON) and tests directory exists
option(BUILD_TESTS "Build test executables and enable CTest" ON)
if(BUILD_TESTS AND EXISTS "${CMAKE_CURRENT_SOURCE_DIR}/tests")
  # Enable CTest before adding tests subdirectory so tests are registered
  include(CTest)
  enable_testing()
  add_subdirectory(tests)
endif()

########################################################################
# Create uninstall target
########################################################################

if(NOT hydrasdr-host_SOURCE_DIR)
configure_file(
  ${PROJECT_SOURCE_DIR}/../cmake/cmake_uninstall.cmake.in
  ${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake
@ONLY)

add_custom_target(uninstall
  COMMENT "Provide hydrasdr-tools uninstall target"
  COMMAND ${CMAKE_COMMAND} -P ${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake
)
endif()

########################################################################
# Install udev rules
########################################################################
option(INSTALL_UDEV_RULES "Install udev rules for HydraSDR" OFF)
if (INSTALL_UDEV_RULES)
  install (
    FILES 51-hydrasdr.rules
    DESTINATION "/etc/udev/rules.d"
    COMPONENT "udev"
  )
else (INSTALL_UDEV_RULES)
  message (STATUS "Udev rules not being installed.")
  message (STATUS "Install them with -DINSTALL_UDEV_RULES=ON")
endif (INSTALL_UDEV_RULES)

########################################################################
# Install mingw64 runtime DLLs (so 'cmake --build . --target install' includes them)
########################################################################
# You can override it on the configure command line:
#   -DMINGW_MSYS64_BIN_DIR="C:/msys64/mingw64/bin"
set(MINGW_MSYS64_BIN_DIR "C:/msys64/mingw64/bin" CACHE PATH "MSYS2 MinGW64 bin directory (used to find runtime DLLs on MinGW builds)")

if(WIN32 AND MINGW)
  # Common runtime DLLs used by the built tools
  set(_mingw_dlls
    libusb-1.0.dll
    libwinpthread-1.dll
  )

  foreach(_dll IN LISTS _mingw_dlls)
    # prefer forward slashes for portability
    set(_dll_path "${MINGW_MSYS64_BIN_DIR}/${_dll}")
    if(EXISTS "${_dll_path}")
      install(FILES "${_dll_path}" DESTINATION ${CMAKE_INSTALL_BINDIR})
    else()
      message(WARNING "Mingw DLL ${_dll} not found at ${_dll_path}; it will not be installed.")
    endif()
  endforeach()
endif()

=== libhydrasdr/CMakeLists.txt ===
# Copyright 2012 Jared Boone
# Copyright 2013-2026 Benjamin Vernoux
#
# This file is part of HydraSDR (based on HackRF project).
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2, or (at your option)
# any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; see the file COPYING.  If not, write to
# the Free Software Foundation, Inc., 51 Franklin Street,
# Boston, MA 02110-1301, USA.

cmake_minimum_required(VERSION 3.10)
project(libhydrasdr LANGUAGES C)
include(GNUInstallDirs)
include(GenerateExportHeader)

file(READ ${CMAKE_CURRENT_SOURCE_DIR}/src/hydrasdr.h HYDRASDR_H_CONTENTS)

STRING(REGEX MATCH "\#define HYDRASDR_VER_MAJOR[ \t]+([0-9]+)"
  HYDRASDR_VER_MJ ${HYDRASDR_H_CONTENTS})
STRING(REGEX MATCH "([0-9]+)" HYDRASDR_VER_MJ ${HYDRASDR_VER_MJ})

STRING(REGEX MATCH "\#define HYDRASDR_VER_MINOR[ \t]+([0-9]+)"
  HYDRASDR_VER_MI ${HYDRASDR_H_CONTENTS})
STRING(REGEX MATCH "([0-9]+)" HYDRASDR_VER_MI ${HYDRASDR_VER_MI})

STRING(REGEX MATCH "\#define HYDRASDR_VER_REVISION[ \t]+([0-9]+)"
  HYDRASDR_VER_RE ${HYDRASDR_H_CONTENTS})
STRING(REGEX MATCH "([0-9]+)" HYDRASDR_VER_RE ${HYDRASDR_VER_RE})

set(HYDRASDR_VER_MAJOR ${HYDRASDR_VER_MJ})
set(HYDRASDR_VER_MINOR ${HYDRASDR_VER_MI})
set(HYDRASDR_VER_REVISION ${HYDRASDR_VER_RE})

set(VERSION_STRING ${HYDRASDR_VER_MAJOR}.${HYDRASDR_VER_MINOR})
set(VERSION ${VERSION_STRING})
set(CMAKE_MODULE_PATH ${PROJECT_SOURCE_DIR}/../cmake/modules)

if(APPLE)
  set(GR_LIBRARY_DIR "lib")
  if(NOT CMAKE_INSTALL_NAME_DIR)
    set(CMAKE_INSTALL_NAME_DIR
      ${CMAKE_INSTALL_PREFIX}/${GR_LIBRARY_DIR} CACHE
      PATH "Library Install Name Destination Directory" FORCE)
  endif(NOT CMAKE_INSTALL_NAME_DIR)
  if(NOT CMAKE_INSTALL_RPATH)
    set(CMAKE_INSTALL_RPATH
      ${CMAKE_INSTALL_PREFIX}/${GR_LIBRARY_DIR} CACHE
      PATH "Library Install RPath" FORCE)
  endif(NOT CMAKE_INSTALL_RPATH)
  if(NOT CMAKE_BUILD_WITH_INSTALL_RPATH)
    set(CMAKE_BUILD_WITH_INSTALL_RPATH ON CACHE
      BOOL "Do Build Using Library Install RPath" FORCE)
  endif(NOT CMAKE_BUILD_WITH_INSTALL_RPATH)
endif(APPLE)

if(MSVC)
  set(THREADS_USE_PTHREADS_WIN32 true)
else()
  add_definitions(-Wall)

  include(TestBigEndian)
  TEST_BIG_ENDIAN(BIGENDIAN)
  if(${BIGENDIAN})
    add_definitions(-DHYDRASDR_BIG_ENDIAN)
  endif(${BIGENDIAN})
endif()

# Find dependencies
# Note: For MSVC builds, these are pre-configured by top-level CMakeLists.txt via FetchContent
if(NOT TARGET LIBUSB::LIBUSB)
  find_package(LIBUSB REQUIRED)
endif()

# For MSVC with FetchContent, pthreads is handled via pthreads4w_static target
# For other platforms, use standard Threads package
if(NOT (MSVC AND TARGET pthreads4w_static))
  find_package(Threads REQUIRED)
endif()

add_subdirectory(src)

########################################################################
# Set library versioning for proper symlink creation by ldconfig
# This ensures ldconfig creates:
#   libhydrasdr.so -> libhydrasdr.so.X
#   libhydrasdr.so.X -> libhydrasdr.so.X.Y.Z
#   libhydrasdr.so.X.Y.Z (actual library)
########################################################################
set_target_properties(hydrasdr PROPERTIES
    VERSION ${HYDRASDR_VER_MAJOR}.${HYDRASDR_VER_MINOR}.${HYDRASDR_VER_REVISION}
    SOVERSION ${HYDRASDR_VER_MAJOR}
)

########################################################################
# Create Cmake Config-file package interface
# (Skip for MSVC FetchContent builds which are self-contained)
########################################################################
if(NOT (MSVC AND TARGET pthreads4w_static))
  include(CMakePackageConfigHelpers)
  write_basic_package_version_file(
    "${CMAKE_CURRENT_BINARY_DIR}/HydraSDR/HydraSDRConfigVersion.cmake"
    VERSION ${VERSION_STRING}
    COMPATIBILITY AnyNewerVersion
  )

  export(EXPORT HydraSDRTargets
    FILE "${CMAKE_CURRENT_BINARY_DIR}/HydraSDR/HydraSDRTargets.cmake"
    NAMESPACE HydraSDR::
  )
  configure_file(HydraSDRConfig.cmake
    "${CMAKE_CURRENT_BINARY_DIR}/HydraSDR/HydraSDRConfig.cmake"
    COPYONLY
  )

  set(CONFIG_PACKAGE_LOCATION ${CMAKE_INSTALL_LIBDIR}/cmake/HydraSDR)
  install(EXPORT HydraSDRTargets
    FILE
      HydraSDRTargets.cmake
    NAMESPACE
      HydraSDR::
    DESTINATION
      ${CONFIG_PACKAGE_LOCATION}
  )
  install(
    FILES
      HydraSDRConfig.cmake
      ../cmake/modules/FindLIBUSB.cmake
      "${CMAKE_CURRENT_BINARY_DIR}/HydraSDR/HydraSDRConfigVersion.cmake"
    DESTINATION
      ${CONFIG_PACKAGE_LOCATION}
    COMPONENT
      Devel
  )
endif()

########################################################################
# Create Pkg Config File
########################################################################
FOREACH(inc ${LIBUSB_INCLUDE_DIR})
  LIST(APPEND HYDRASDR_PC_CFLAGS "-I${inc}")
ENDFOREACH(inc)

# use space-separation format for the pc file
STRING(REPLACE ";" " " HYDRASDR_PC_CFLAGS "${HYDRASDR_PC_CFLAGS}")
STRING(REPLACE ";" " " HYDRASDR_PC_LIBS "${HYDRASDR_PC_LIBS}")

# unset these vars to avoid hard-coded paths to cross environment
IF(CMAKE_CROSSCOMPILING)
  UNSET(HYDRASDR_PC_CFLAGS)
  UNSET(HYDRASDR_PC_LIBS)
ENDIF(CMAKE_CROSSCOMPILING)

set(prefix ${CMAKE_INSTALL_PREFIX})
set(exec_prefix \${prefix})
set(libdir \${exec_prefix}/lib${LIB_SUFFIX})
set(includedir \${prefix}/include)

CONFIGURE_FILE(
  ${CMAKE_CURRENT_SOURCE_DIR}/libhydrasdr.pc.in
  ${CMAKE_CURRENT_BINARY_DIR}/libhydrasdr.pc
@ONLY)

INSTALL(
  FILES ${CMAKE_CURRENT_BINARY_DIR}/libhydrasdr.pc
  DESTINATION ${CMAKE_INSTALL_LIBDIR}/pkgconfig
)

########################################################################
# Create uninstall target
########################################################################
if(NOT hydrasdr-host_SOURCE_DIR)
configure_file(
  ${PROJECT_SOURCE_DIR}/../cmake/cmake_uninstall.cmake.in
  ${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake
@ONLY)

add_custom_target(uninstall
  COMMENT "Provide libhydrasdr uninstall target"
  COMMAND ${CMAKE_COMMAND} -P ${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake
)
endif()

=== hydrasdr-tools/src/CMakeLists.txt ===
# Copyright 2012 Jared Boone
# Copyright 2013-2026 Benjamin Vernoux
#
# This file is part of HydraSDR (based on HackRF project).
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2, or (at your option)
# any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; see the file COPYING.  If not, write to
# the Free Software Foundation, Inc., 51 Franklin Street,
# Boston, MA 02110-1301, USA.

# Standard tools use shared library if available, otherwise static
if(TARGET HydraSDR::hydrasdr)
  list(APPEND TOOLS_LINK_LIBS HydraSDR::hydrasdr)
else()
  list(APPEND TOOLS_LINK_LIBS hydrasdr_static)
endif()

# DDC test tools must use static library (iqconverter is internal API)
# Use direct target name for in-tree builds
list(APPEND DDC_TOOLS_LINK_LIBS hydrasdr_static)

if(MSVC)
  add_library(libgetopt_static STATIC
    ${CMAKE_CURRENT_SOURCE_DIR}/../getopt/getopt.c)
  list(APPEND TOOLS_LINK_LIBS libgetopt_static)
endif()

add_executable(hydrasdr_gpio hydrasdr_gpio.c)
target_link_libraries(hydrasdr_gpio ${TOOLS_LINK_LIBS})
install(TARGETS hydrasdr_gpio RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR})

add_executable(hydrasdr_gpiodir hydrasdr_gpiodir.c)
target_link_libraries(hydrasdr_gpiodir ${TOOLS_LINK_LIBS})
install(TARGETS hydrasdr_gpiodir RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR})

add_executable(hydrasdr_lib_version hydrasdr_lib_version.c)
target_link_libraries(hydrasdr_lib_version ${TOOLS_LINK_LIBS})
install(TARGETS hydrasdr_lib_version RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR})

# Clock generator tool (modern HAL-based API)
add_executable(hydrasdr_clockgen hydrasdr_clockgen.c)
target_link_libraries(hydrasdr_clockgen ${TOOLS_LINK_LIBS})
install(TARGETS hydrasdr_clockgen RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR})

# Legacy SI5351C tool (deprecated, kept for backward compatibility)
add_executable(hydrasdr_si5351c hydrasdr_si5351c.c)
target_link_libraries(hydrasdr_si5351c ${TOOLS_LINK_LIBS})
install(TARGETS hydrasdr_si5351c RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR})

# Legacy R82x tuner tool (deprecated, RFOne only - use hydrasdr_rf_frontend instead)
add_executable(hydrasdr_r82x hydrasdr_r82x.c)
target_link_libraries(hydrasdr_r82x ${TOOLS_LINK_LIBS})
install(TARGETS hydrasdr_r82x RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR})

# RF frontend register access tool (modern HAL-based API)
add_executable(hydrasdr_rf_frontend hydrasdr_rf_frontend.c)
target_link_libraries(hydrasdr_rf_frontend ${TOOLS_LINK_LIBS})
install(TARGETS hydrasdr_rf_frontend RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR})

add_executable(hydrasdr_spiflash hydrasdr_spiflash.c)
target_link_libraries(hydrasdr_spiflash ${TOOLS_LINK_LIBS})
install(TARGETS hydrasdr_spiflash RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR})

add_executable(hydrasdr_calibrate hydrasdr_calibrate.c)
target_link_libraries(hydrasdr_calibrate ${TOOLS_LINK_LIBS})
install(TARGETS hydrasdr_calibrate RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR})

add_executable(hydrasdr_info hydrasdr_info.c)
target_link_libraries(hydrasdr_info ${TOOLS_LINK_LIBS})
install(TARGETS hydrasdr_info RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR})

# Note: DLL copying is handled by libhydrasdr's POST_BUILD on the hydrasdr target
# This ensures DLLs are copied whenever the library is rebuilt

add_executable(hydrasdr_rx hydrasdr_rx.c)
target_link_libraries(hydrasdr_rx ${TOOLS_LINK_LIBS})
install(TARGETS hydrasdr_rx RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR})

# Async RX tool - modern cross-platform streaming example
add_executable(hydrasdr_async_rx hydrasdr_async_rx.c)
target_link_libraries(hydrasdr_async_rx ${TOOLS_LINK_LIBS})
install(TARGETS hydrasdr_async_rx RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR})

add_executable(hydrasdr_reset hydrasdr_reset.c)
target_link_libraries(hydrasdr_reset ${TOOLS_LINK_LIBS})
install(TARGETS hydrasdr_reset RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR})

add_executable(hydrasdr_set_rf_port hydrasdr_set_rf_port.c)
target_link_libraries(hydrasdr_set_rf_port ${TOOLS_LINK_LIBS})
install(TARGETS hydrasdr_set_rf_port RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR})

add_executable(hydrasdr_list_devices hydrasdr_list_devices.c)
target_link_libraries(hydrasdr_list_devices ${TOOLS_LINK_LIBS})
install(TARGETS hydrasdr_list_devices RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR})

# DDC benchmark tool - uses internal iqconverter API (requires static linking)
add_executable(hydrasdr_ddc_benchmark hydrasdr_ddc_benchmark.c cpu_features.c)
target_include_directories(hydrasdr_ddc_benchmark PRIVATE ${CMAKE_SOURCE_DIR}/libhydrasdr/src ${CMAKE_CURRENT_SOURCE_DIR})
target_compile_definitions(hydrasdr_ddc_benchmark PRIVATE
  ADD_EXPORTS
  BUILD_OPT_FLAGS="${CMAKE_C_FLAGS_RELEASE}"
)
target_link_libraries(hydrasdr_ddc_benchmark ${DDC_TOOLS_LINK_LIBS})
install(TARGETS hydrasdr_ddc_benchmark RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR})

# API benchmark tool - comprehensive API & USB latency testing
# Uses internal iqconverter API (requires static linking)
add_executable(hydrasdr_api_benchmark hydrasdr_api_benchmark.c cpu_features.c)
target_include_directories(hydrasdr_api_benchmark PRIVATE ${CMAKE_SOURCE_DIR}/libhydrasdr/src ${CMAKE_CURRENT_SOURCE_DIR})
target_compile_definitions(hydrasdr_api_benchmark PRIVATE ADD_EXPORTS)
target_link_libraries(hydrasdr_api_benchmark ${DDC_TOOLS_LINK_LIBS})
if(NOT MSVC)
  target_link_libraries(hydrasdr_api_benchmark m)
endif()
install(TARGETS hydrasdr_api_benchmark RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR})

#######################################################################
# Copy DLLs to tools output directory
#######################################################################
if(WIN32)
  if(TARGET hydrasdr)
    if(MSVC)
      # MSVC: Copy to config-specific Release directory
      set(_TOOLS_RELEASE_DIR "${CMAKE_CURRENT_BINARY_DIR}/Release")
      add_custom_target(copy_dlls ALL
        COMMAND ${CMAKE_COMMAND} -E make_directory "${_TOOLS_RELEASE_DIR}"
        COMMAND ${CMAKE_COMMAND} -E copy_if_different
          "${CMAKE_CURRENT_BINARY_DIR}/hydrasdr.dll"
          "${_TOOLS_RELEASE_DIR}/"
        COMMAND ${CMAKE_COMMAND} -E copy_if_different
          "${LIBUSB_DLL}"
          "${_TOOLS_RELEASE_DIR}/"
        COMMENT "Copying hydrasdr.dll and libusb-1.0.dll to Release directory"
      )
      add_dependencies(copy_dlls hydrasdr hydrasdr_info)
    elseif(MINGW)
      # MinGW: Copy to tools directory
      if(LIBUSB_1_0_DLL AND EXISTS "${LIBUSB_1_0_DLL}")
        add_custom_target(copy_dlls ALL
          COMMAND ${CMAKE_COMMAND} -E copy_if_different
            "$<TARGET_FILE:hydrasdr>"
            "$<TARGET_FILE_DIR:hydrasdr_info>/"
          COMMAND ${CMAKE_COMMAND} -E copy_if_different
            "${LIBUSB_1_0_DLL}"
            "$<TARGET_FILE_DIR:hydrasdr_info>/"
          COMMENT "Copying hydrasdr.dll and libusb-1.0.dll to tools directory"
        )
        add_dependencies(copy_dlls hydrasdr hydrasdr_info)
      else()
        add_custom_target(copy_dlls ALL
          COMMAND ${CMAKE_COMMAND} -E copy_if_different
            "$<TARGET_FILE:hydrasdr>"
            "$<TARGET_FILE_DIR:hydrasdr_info>/"
          COMMENT "Copying hydrasdr.dll to tools directory"
        )
        add_dependencies(copy_dlls hydrasdr hydrasdr_info)
      endif()
    endif()
  endif()
endif()

=== libhydrasdr/src/CMakeLists.txt ===
# Copyright (c) 2012, Jared Boone <jared@sharebrained.com>
# Copyright (c) 2013, Michael Ossmann <mike@ossmann.com>
# Copyright (c) 2013, Youssef Touil <youssef@airspy.com>
# Copyright (c) 2013-2026, Benjamin Vernoux <bvernoux@hydrasdr.com>
#
# This file is part of HydraSDR (based on AirSpy & HackRF project).
#
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# Redistributions of source code must retain the above copyright
# notice, this list of conditions and the following
# disclaimer. Redistributions in binary form must reproduce the above
# copyright notice, this list of conditions and the following
# disclaimer in the documentation and/or other materials provided with
# the distribution. Neither the name of HydraSDR nor the
# names of its contributors may be used to endorse or promote products
# derived from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
# FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
# COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
# INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
# BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
# LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
# CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
# LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
# ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
# POSSIBILITY OF SUCH DAMAGE.

option(ENABLE_STATIC_LIB "Build and Install libhydrasdr.a static library" ON)
option(ENABLE_SHARED_LIB "Build and Install libhydrasdr.so shared library" ON)
option(
  DISABLE_USB_DEVICE_DISCOVERY
  "Prevent libusb from trying to enumerate devices. Useful on non-root android"
  ANDROID)

# Targets
set(_C_SOURCES_
  ${CMAKE_CURRENT_SOURCE_DIR}/hydrasdr.c
  ${CMAKE_CURRENT_SOURCE_DIR}/hydrasdr_shared.c
  ${CMAKE_CURRENT_SOURCE_DIR}/hydrasdr_rfone.c
  ${CMAKE_CURRENT_SOURCE_DIR}/iqconverter.c
  ${CMAKE_CURRENT_SOURCE_DIR}/iqconverter_lut.c
  ${CMAKE_CURRENT_SOURCE_DIR}/iqconverter_float.c
  ${CMAKE_CURRENT_SOURCE_DIR}/iqconverter_int16.c
  ${CMAKE_CURRENT_SOURCE_DIR}/iqconverter_float_opt.c
  ${CMAKE_CURRENT_SOURCE_DIR}/iqconverter_int16_opt.c
  ${CMAKE_CURRENT_SOURCE_DIR}/iqconverter_float_opt33.c
  ${CMAKE_CURRENT_SOURCE_DIR}/iqconverter_int16_opt33.c
  ${CMAKE_CURRENT_SOURCE_DIR}/iqconverter_float_opt65.c
  ${CMAKE_CURRENT_SOURCE_DIR}/iqconverter_int16_opt65.c
  ${CMAKE_CURRENT_SOURCE_DIR}/iqconverter_float_opt83.c
  ${CMAKE_CURRENT_SOURCE_DIR}/iqconverter_int16_opt83.c
  ${CMAKE_CURRENT_SOURCE_DIR}/iqconverter_decimator.c
  ${CMAKE_CURRENT_SOURCE_DIR}/iqconverter_float_opt_dec.c
  ${CMAKE_CURRENT_SOURCE_DIR}/iqconverter_int16_opt_dec.c
  CACHE INTERNAL "List of C sources")
set(_C_HEADERS_
  ${CMAKE_CURRENT_SOURCE_DIR}/hydrasdr.h
  ${CMAKE_CURRENT_SOURCE_DIR}/hydrasdr_commands.h
  ${CMAKE_CURRENT_SOURCE_DIR}/hydrasdr_internal.h
  ${CMAKE_CURRENT_SOURCE_DIR}/hydrasdr_shared.h
  ${CMAKE_CURRENT_SOURCE_DIR}/iqconverter.h
  ${CMAKE_CURRENT_SOURCE_DIR}/iqconverter_lut.h
  ${CMAKE_CURRENT_SOURCE_DIR}/iqconverter_float.h
  ${CMAKE_CURRENT_SOURCE_DIR}/iqconverter_int16.h
  ${CMAKE_CURRENT_SOURCE_DIR}/iqconverter_float_opt.h
  ${CMAKE_CURRENT_SOURCE_DIR}/iqconverter_int16_opt.h
  ${CMAKE_CURRENT_SOURCE_DIR}/iqconverter_float_opt33.h
  ${CMAKE_CURRENT_SOURCE_DIR}/iqconverter_int16_opt33.h
  ${CMAKE_CURRENT_SOURCE_DIR}/iqconverter_float_opt65.h
  ${CMAKE_CURRENT_SOURCE_DIR}/iqconverter_int16_opt65.h
  ${CMAKE_CURRENT_SOURCE_DIR}/iqconverter_float_opt83.h
  ${CMAKE_CURRENT_SOURCE_DIR}/iqconverter_int16_opt83.h
  ${CMAKE_CURRENT_SOURCE_DIR}/iqconverter_decimator.h
  ${CMAKE_CURRENT_SOURCE_DIR}/iqconverter_float_opt_dec.h
  ${CMAKE_CURRENT_SOURCE_DIR}/iqconverter_int16_opt_dec.h
  ${CMAKE_CURRENT_SOURCE_DIR}/filters.h
  ${CMAKE_CURRENT_SOURCE_DIR}/filters_opt.h
  ${CMAKE_CURRENT_SOURCE_DIR}/compat_opt.h
  ${CMAKE_CURRENT_SOURCE_DIR}/spsc_queue.h
  ${CMAKE_CURRENT_SOURCE_DIR}/buffer_pool.h
  CACHE INTERNAL "List of C headers")

# For cygwin just force UNIX OFF and WIN32 ON
if( ${CYGWIN} )
  SET(UNIX OFF)
  SET(WIN32 ON)
endif( ${CYGWIN} )

if(${WIN32})
  if(NOT MINGW)
    list(APPEND _C_SOURCES_ win32/hydrasdr.rc)
  endif()
endif()

if(MINGW)
  # This gets us DLL resource information when compiling on MinGW.
  if(NOT CMAKE_RC_COMPILER)
    set(CMAKE_RC_COMPILER windres.exe)
  endif()

  add_custom_command(OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/hydrasdrrc.obj
    DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/hydrasdr.h
    COMMENT "Resource compiler used to generate hydrasdr.obj"
    COMMAND ${CMAKE_RC_COMPILER}
    -D GCC_WINDRES
    -I ${CMAKE_CURRENT_SOURCE_DIR}
    -I ${CMAKE_CURRENT_BINARY_DIR}
    -o ${CMAKE_CURRENT_BINARY_DIR}/hydrasdrrc.obj
    -i ${CMAKE_CURRENT_SOURCE_DIR}/win32/hydrasdr.rc)
  set(HYDRASDR_DLL_OBJS ${CMAKE_CURRENT_BINARY_DIR}/hydrasdrrc.obj)
  SET_SOURCE_FILES_PROPERTIES(
    ${HYDRASDR_DLL_OBJS}
    PROPERTIES
    EXTERNAL_OBJECT true
    GENERATED true)
endif(MINGW)

# Settings common for shared and static libraries
function(libhydrasdr_common_settings libtarget)
  set_target_properties(${libtarget} PROPERTIES CLEAN_DIRECT_OUTPUT 1)

  target_include_directories(
    ${libtarget} PUBLIC
    $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}>
    $<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDEDIR}>
    $<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDEDIR}/libhydrasdr>)

  # ============================================================================
  # PORTABLE OPTIMIZATION FLAGS
  # These flags improve performance while maintaining portability across:
  # - x86/x86-64: GCC, Clang, MinGW, MSVC
  # - ARM32/ARM64: GCC, Clang (RPi3/4/5, Apple Silicon)
  # ============================================================================

  if(CMAKE_C_COMPILER_ID MATCHES "GNU|Clang" OR MINGW)
    # Base optimization (Release only)
    target_compile_options(${libtarget} PRIVATE
      $<$<CONFIG:Release>:-O3>
    )

    # Vectorization and loop optimizations (Release only)
    target_compile_options(${libtarget} PRIVATE
      $<$<CONFIG:Release>:-ftree-vectorize>      # Enable auto-vectorization
      $<$<CONFIG:Release>:-funroll-loops>        # Unroll loops for better pipelining
      $<$<CONFIG:Release>:-fomit-frame-pointer>  # Free up a register
    )

    # Safe floating-point optimizations (Release only)
    # These are safe for DSP/SDR: no NaN/Inf handling needed, no errno
    target_compile_options(${libtarget} PRIVATE
      $<$<CONFIG:Release>:-fno-math-errno>       # Don't set errno for math funcs
      $<$<CONFIG:Release>:-fno-trapping-math>    # Assume no FP traps
      $<$<CONFIG:Release>:-fno-signed-zeros>     # Ignore signed zero (-0.0)
    )

    # GCC-specific optimizations
    if(CMAKE_C_COMPILER_ID STREQUAL "GNU")
      target_compile_options(${libtarget} PRIVATE
        $<$<CONFIG:Release>:-ftree-loop-distribution>  # Better cache usage
        $<$<CONFIG:Release>:-ftree-loop-vectorize>     # Loop vectorization
      )
      # GCC 11+ has improved vectorizer
      if(CMAKE_C_COMPILER_VERSION VERSION_GREATER_EQUAL "11.0")
        target_compile_options(${libtarget} PRIVATE
          $<$<CONFIG:Release>:-fvect-cost-model=dynamic>  # Better vector decisions
        )
      endif()
    endif()

    # Clang-specific optimizations
    if(CMAKE_C_COMPILER_ID STREQUAL "Clang")
      target_compile_options(${libtarget} PRIVATE
        $<$<CONFIG:Release>:-fvectorize>           # Enable vectorization
        $<$<CONFIG:Release>:-fslp-vectorize>       # Enable SLP vectorization
      )
    endif()

    # ARM-specific optimizations (RPi3/4/5, Apple Silicon)
    if(CMAKE_SYSTEM_PROCESSOR MATCHES "aarch64|arm64|ARM64")
      # ARM64: NEON is mandatory, optimize for native CPU
      message(STATUS "ARM64 detected: enabling native CPU optimizations")
    elseif(CMAKE_SYSTEM_PROCESSOR MATCHES "armv7|armv6|arm")
      # ARM32 (RPi3 in 32-bit mode): Enable NEON/VFP if available
      # Android NDK only supports softfp, skip hard float ABI
      if(NOT ANDROID)
        target_compile_options(${libtarget} PRIVATE
          $<$<CONFIG:Release>:-mfpu=neon-vfpv4>      # Enable NEON
          $<$<CONFIG:Release>:-mfloat-abi=hard>      # Use hardware FP
        )
      endif()
      message(STATUS "ARM32 detected: enabling NEON/VFPv4 optimizations")
    endif()

  endif()

  # MSVC optimizations (Visual Studio 2019/2022+)
  if(MSVC)
    target_compile_options(${libtarget} PRIVATE
      # Fast floating-point (safe for DSP)
      $<$<CONFIG:Release>:/fp:fast>
      # Enable intrinsic functions
      $<$<CONFIG:Release>:/Oi>
      # Favor fast code over small code
      $<$<CONFIG:Release>:/Ot>
      # Whole program optimization
      $<$<CONFIG:Release>:/GL>
    )
    # Enable AVX for x64 builds (baseline for modern CPUs)
    if(CMAKE_SIZEOF_VOID_P EQUAL 8)
      target_compile_options(${libtarget} PRIVATE
        $<$<CONFIG:Release>:/arch:AVX>
      )
      message(STATUS "MSVC x64: enabling AVX baseline")
    endif()
    # Linker optimization for whole program optimization
    target_link_options(${libtarget} PRIVATE
      $<$<CONFIG:Release>:/LTCG>
    )
  endif()

  # Dependencies
  target_link_libraries(${libtarget} PRIVATE LIBUSB::LIBUSB)

  if(MINGW)
    # For MinGW, we want to link system libs and pthreads statically
    # so the DLL doesn't depend on libwinpthread-1.dll or libgcc_s_seh-1.dll.
    target_link_options(${libtarget} PRIVATE -static-libgcc -static-libstdc++)

    # Link winpthread statically, then switch back to dynamic for other libs (like libusb)
    target_link_libraries(${libtarget} PRIVATE -Wl,-Bstatic -lwinpthread -Wl,-Bdynamic)
  elseif(MSVC AND TARGET pthreads4w_static)
    # MSVC with FetchContent: pthreads handled in WIN32 section below
  elseif(TARGET Threads::Threads)
    # Standard behavior for Linux (POSIX threads)
    target_link_libraries(${libtarget} PRIVATE Threads::Threads)
  endif()

  if( ${UNIX} )
    install(TARGETS ${libtarget} EXPORT HydraSDRTargets
      LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
      COMPONENT sharedlibs)
  endif( ${UNIX} )
  if( ${WIN32} )
    if(MSVC AND TARGET pthreads4w_static)
      # Use FetchContent-built pthreads4w static library (no DLL dependency)
      target_link_libraries(${libtarget} PRIVATE pthreads4w_static)
      target_compile_definitions(${libtarget} PRIVATE PTW32_STATIC_LIB)
    elseif( THREADS_PTHREADS_WIN32_LIBRARY AND NOT MINGW )
      # Fallback: use external pthread lib definition if NOT MinGW (handled above)
      target_link_libraries(${libtarget} PRIVATE ${THREADS_PTHREADS_WIN32_LIBRARY} )
    endif()
    if( THREADS_PTHREADS_INCLUDE_DIR )
      target_include_directories(${libtarget} PRIVATE ${THREADS_PTHREADS_INCLUDE_DIR})
    endif()
    target_include_directories(${libtarget} PRIVATE ${CMAKE_CURRENT_SOURCE_DIR}/win32 )
    if(MSVC AND TARGET pthreads4w_static)
      # MSVC FetchContent builds: install without export (self-contained)
      install(TARGETS ${libtarget}
        RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
        LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
        ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
        COMPONENT sharedlibs)
    elseif(MINGW)
      # MinGW builds: install DLL to bin, import lib (.dll.a) to lib
      install(TARGETS ${libtarget} EXPORT HydraSDRTargets
        RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
        ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
        COMPONENT sharedlibs)
    else()
      install(TARGETS ${libtarget} EXPORT HydraSDRTargets
        DESTINATION bin
        COMPONENT sharedlibs)
    endif()
  endif( ${WIN32} )

  # Enable static runtime for both debug and release
  if(MSVC)

=== debian/changelog ===
hydrasdr-host (1.1.0-1) experimental; urgency=medium

  * New upstream release
  * New upstream repository -> new source package name.
  * Library soversion bump -> new library package name
    upload to experimental.

 -- A. Maitland Bottoms <bottoms@debian.org>  Sat, 07 Feb 2026 21:15:44 -0500

rfone-host (1.0.3-1) unstable; urgency=medium

  * New upstream release

 -- A. Maitland Bottoms <bottoms@debian.org>  Mon, 20 Oct 2025 22:49:03 -0400

rfone-host (1.0.2-1) experimental; urgency=medium

  * New package (Closes: 1111685)

 -- A. Maitland Bottoms <bottoms@debian.org>  Mon, 13 Oct 2025 20:28:53 -0400

=== debian/control ===
Source: hydrasdr-host
Section: comm
Priority: optional
Maintainer: Debian Hamradio Maintainers <debian-hams@lists.debian.org>
Uploaders: A. Maitland Bottoms <bottoms@debian.org>
Build-Depends: cmake,
               debhelper-compat (= 13),
               libusb-1.0-0-dev,
               pkgconf
Standards-Version: 4.7.3
Rules-Requires-Root: no
Homepage: https://hydrasdr.com
Vcs-Browser: https://salsa.debian.org/debian-hamradio-team/hydrasdr-host
Vcs-Git: https://salsa.debian.org/debian-hamradio-team/hydrasdr-host.git

Package: hydrasdr-tools
Architecture: any
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, libhydrasdr1 (= ${binary:Version}), ${misc:Depends}
Description: HydraSDR RFOne software defined radio receiver - user runtime
 HydraSDR RFOne is an open source Software Defined Radio that can
 receive 24-1850 MHz.
 It is a High Speed USB device powered by the USB bus.
 .
 This package contains some utility applications.
  * hydrasdr_gpio
  * hydrasdr_lib_version
  * hydrasdr_info: probe device and show configuration
  * hydrasdr_rx
  * hydrasdr_calibrate

Package: libhydrasdr-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: libhydrasdr1 (= ${binary:Version}), ${misc:Depends}
Description: HydraSDR RFOne software defined radio receiver - development
 HydraSDR RFOne is an open source Software Defined Radio that can
 receive 24-1850 MHz.
 It is a High Speed USB device powered by the USB bus.
 .
 This package contains development files.

Package: libhydrasdr1
Section: libs
Architecture: any
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends}, ${shlibs:Depends}
Multi-Arch: same
Description: HydraSDR RFOne software defined radio receiver - library
 HydraSDR RFOne is an open source Software Defined Radio that can
 receive 24-1850 MHz.
 It is a High Speed USB device powered by the USB bus.
 .
 This package contains the shared library.

=== debian/watch ===
Version: 5

Template: Github
Owner: hydrasdr
Project: hydrasdr-host
Update-Script: uupdate
